use std::collections::HashSet;

use std::cell::RefCell;

use super::GlobalNamespace;

#[derive(Clone, Copy)]
pub struct Trait<'a> {
    pub(super) id: usize,
    pub(super) namespace: &'a GlobalNamespace,
}

pub(super) struct InternalTrait {
    // make resolution easier
    pub(super) types: RefCell<HashSet<usize>>,
    pub(super) name: String,
}
